#!/bin/tclsh

# perplex glFTPD iP-BAN v1.0 by meTa/ppx 2003
#
# installation:
#
# READ INSTALL 
# and add to glftpd.conf
# cscript         CWD                     pre             /bin/ppx-ib.tcl
# cscript         PWD                     pre             /bin/ppx-ib.tcl
# cscript         PASV                    pre             /bin/ppx-ib.tcl
# cscript         PORT                    pre             /bin/ppx-ib.tcl
# cscript         LIST                    pre             /bin/ppx-ib.tcl
# cscript         STAT                    pre             /bin/ppx-ib.tcl
# cscript         RMD                     pre             /bin/ppx-ib.tcl
# cscript         DELE                    pre             /bin/ppx-ib.tcl
# cscript         SITE                    pre             /bin/ppx-ib.tcl
#
#
# todo: add custom denied-messages

# Banned Lamers
set banIP(0) "sample@192.168.*.10"

# config done.
# dont mess with anything below this line.
#
#########################################################

set debug    0
set host     $env(HOST)

proc dbg { text { pref "DBG" } } {
        global debug

        if { $debug } {
                if { [string length $pref] == 3 } { set pref "$pref " }
                if { [string length $pref] >  4 } { set pref [string range $pref 0 3] }
                puts "230$pref: $text"
        }
}

proc doIt { argv } {
        global banIP host rc

        set rc    0

        foreach { command user group } $argv { break }
        set dir [string range $command 4 end]
        set dir [file split $dir]

        dbg $command "CMD"

        if { [llength $dir] == 1 } {
                set ndir [file split [pwd]]
                append ndir " " $dir
                set dir [lreplace $ndir 1 1]
        }

        if { [lindex $dir 0] != "/" } { set rc 0; }

        for { set i 0 } { $i < [array size banIP] } { incr i } {
                dbg $i "I  "
                if { [string match -nocase $banIP($i) $host] } { set rc 1; set msg "lamer access denied." }
        }

        if { $rc } { puts "550ERROR: executing command: $command\n550-> $msg"; return }
}

doIt $argv
exit $rc